// Metric -- Non Specific

// -- File: LISTBOXS.CC

/* ----------------------------------------------------------------------
    Description:
 
       This UI file is designed to give some optional ListBoxes
       which can be used either 'as is' or you can even subclass them.
 
    Programmers: 
 
       Romain Strieff/Jim Sare
       Ken Mayer
 
    History: 
 
       03/26/1998 -- First version of this custom class file.

    Instantiation: 
 
       set procedure to listboxs.cc additive
       * create/modify a form, place an instance of one of
       * these listboxes on the form as a normal listbox ...
 
    Classes:
       More details on each of these is contained in the commentary for
       each class ...

       ProcessingListBox
          A simple enough listbox -- it has a default datasource
          of a simple array with the text "Processing ..." --
          can be used when you have a form that takes some time
          to load the datasource ...

   -------------------------------------------------------------------- */

class ProcessingListBox(parentObj) of LISTBOX(parentObj) custom
   /*
      -------------------------------------------------------------------
      -- Description:

         A very simple listbox that simply shows as the
         datasource when a form opens, the word "Processing ...".

         This is useful for those forms that take a bit of time
         to load the array for the listbox for the datasource.

      -- Programmers: 
    
         Ken Mayer
     
      -- History: 
    
         03/28/1998 -- First version (Based on something I saw
                       in some code somewhere or other ...
                           
      -- Instantiation: 
    
          set procedure to listboxs.cc additive
           // create/modify a form, place an instance of this listbox
           //  on the form ...

          // In the form's onOpen, set the dataSource for the listbox
          // in whatever long procedure you need (read in fields
          // from a table, or whatever ...) 

          You can change the text to something else, by changing
          it below in the onOpen event ...
          
      -------------------------------------------------------------------
   */

   with (this)
      onOpen = {; this.dataSource = 'Array {"Processing ..."}' }
   endwith
endclass
// End of Class: ProcessingListBox

/* --------------------------------------------------------------------
   End of File: LISTBOXS.CC
   -------------------------------------------------------------------- */
