/*
   ADO.cc
   Programmer(s)..:Dan Howard, Vic McClung
   Notes........: This class is aimed at providing the ability
                  to connect to the ADO database engine,
                  bypassing the Borland Database Engine (BDE)
                  to work with data. 

                  With some more work, it could be made a bit
                  more generic. 

                  This assumes that you wish to bypass the BDE,
                  which can be done in the Plus.ini OR the 
                  application's INI file with these two lines --
                  doing this means that the BDE itself is NOT
                  loaded at all with dBASE or your application:

                  [DataEngine]
                  DefaultEngine=NONE

                  Sylvio Genco provided this information
                  after doing some testing, not using this
                  class:
                     cn = new OleAutoClient("ADODB.connection")
                     // ado1.mdb is the name of the Access database:
                     cn.Open( "driver={Microsoft Access Driver (*.mdb)}; dbq=ado1.mdb)
                     // 'names' is the table, 'last' and 'first' are 
                     // fields in the table:
                     qString = "SELECT * from names ORDER BY last,first"
                     rs = new OleAutoColent("ADODB.recordset")
                     // cn is the first object:
                     rs.ActiveConnection = cn
                     // qString is the SQL select statement:
                     rs.Source           = qString
                     rs.CursorType       = 3 //?
                     rs.LockType         = 3 //?
                     rs.Open()           // open the table
                     rs.MoveFirst()      // first row
                     // loop through data, display first/last names:
                     do while not rs.EOF()
                        ? rs.fields("first").value+" "+;
                          rs.fields("last").value
                        // next row:
                        rs.MoveNext()
                     enddo

         IF someone with more experience with ADO/Access
         (or other tables that can be used with ADO)
         wanted to modify this class to make it more
         generic (i.e., pass the database name, 
         the SQL Select string, to the class and 
         have it do the rest, etc.), this class could
         be quite useful, as it appears to map
         a bunch of the ADO functionality to the
         OODML object functionality. -- KJM

   Dependencies: :dUFLP:ado.h
                 this file should be copied to 
                 c:/.../dBASE/Plus/include
*/
#include "ado.h"
#define NAVIGATE_NEXT   1
#define NAVIGATE_FIRST  2
#define NAVIGATE_LAST   3
#define STATE_CLOSED    0
#define STATE_BROWSE    1
#define STATE_EDIT      2
#define STATE_APPEND    3
#define STATE_FILTER    4
#define STATE_LOCATE    5

CLASS adoQuery of Query
   this.execute = class::OpenADO
   this.onClose = class::CloseADO
// this stuff should be modified to accept values from
// the coder:
   this.conStr = "Provider=Microsoft.Jet.OLEDB.3.51;Data Source='ado.mdb'"
   this.Provider = "Microsoft.Jet.OLEDB.4.0"
   this.DataSource = "ado.mdb"
   this.sql = "Select * from NAMES ORDER BY LAST,FIRST"
   //this.sql = "NAMES"
   this.fieldCount = 0
   this.CursorLocation = adUseClient
   this.CursorType = adOpenDynamic
   this.LockType = adLockOptimistic
   this.Options = adCmdText
   //this.Options = adCmdTable
   this.requestLive = true
   this.rs = 0
   this.bookobj = 0

   with (this.rowset)
      atFirst := class::ATFIRSTADO
      atLast := class::ATLASTADO
      beginAppend = class::APPENDADO
      abandon = class::abandonADO
      bookmark = class::bookmarkADO
      bookmarksEqual := CLASS::BOOKMARKSEQUALTEXT
      count = class::COUNTADO
      delete = class::DELETEADO
      first = class::FIRSTADO
      goto = class::GOTOADO
      last = class::LASTADO
      lockRow = {||true}
      next = class::NEXTADO
      save = class::SAVEADO
      beginEdit = class::beginEditADO
      onNavigate = class::ONNAVIGATEADO
      canNavigate = class::canNavigateADO
   endwith

   function OpenADO()
      local f
      this.session := null
      if type('this.parent.indesign') = "L"
         if empty(this.conStr)
            this.conStr = this.DataLink()
         endif
      endif
      this.rowset.bookObject = new Object()
      this.rowset.bookObject.cursor = 1
      this.rs = new OleAutoClient("ADODB.recordset")
      if empty(this.conStr)
         this.conStr = 'Provider='+this.Provider+';';
            +'Data Source='+this.DataSource
      endif
      this.rs.open(this.sql, this.conStr, this.CursorType, this.LockType, this.Options)
      this.fieldCount = this.rs.fields.count()
      this.CreateFields()
      // custom eof, since rowset.endOfSet is read-only:
      this.rowset.notifyControls = true
      this.rowset.rs = this.rs
      this.rowset.EOF = this.rs.EOF
      this.rowset.BOF = this.rs.BOF
      this.parent.rowset = this.rowset
      this.rowset.live := true
      this.rowset.modified = false
      this.rowset.AutoEdit := TRUE
      this.rowset.AutoNullFields = FALSE
      //this.rowset.first()
      this.rowset.state := STATE_BROWSE
      return true


   function CloseADO()
      this.rowset.state := STATE_CLOSED
      this.rs.Close()
      this.type = 0
      this.EOF = false
      this.BOF = false

   function countADO()
      return this.rs.recordcount

   function bookmarkADO()
      return this.rs.bookmark

   function beginEditADO()
      this.state = STATE_EDIT
      return true

   function AppendADO()
      local i
      //ROWSET::BEGINAPPEND()
      //this.rs.AddNew()
      clear
      for i = 1 to this.rs.fields.count
         k = i - 1
         this.fields[i].value = iif( this.fields[i].FieldType == "VarChar", space(this.fields[i].length), null)
         ? this.fields[i].fieldname
         ?? " "+this.fields[i].type
      next
      this.modified = TRUE
      this.state := STATE_APPEND
      this.refreshControls()
      return

   function abandonADO()
      this.rs.CancelUpdate()
      class::populateADO()
      this.state := STATE_BROWSE
      this.refreshControls()
      return

   function saveADO()
      local i, k, v
      if ( not this.state == STATE_CLOSED )
         ROWSET::SAVE()
         this.modified := false
         if this.state == STATE_APPEND
            this.rs.AddNew()
            //class::lastADO()
         endif
         for i = 1 to this.rs.fields.count
            k = i - 1
            this.rs.fields(k).value = this.fields[i].value
            this.fields[i].baseValue = this.fields[i].value
            this.rs.update(this.rs.fields(k).name, this.fields[i].value)
         next
      endif
      this.state = STATE_BROWSE
      this.refreshControls()
      return true

   function deleteADO()
      this.rs.Delete()
      return

   function firstADO()
      if not this.canNavigate()
         return
      endif
      this.rs.MoveFirst()
      class::populateADO()
      return this.onNavigate()

   function lastADO()
      this.rs.MoveLast()
      class::populateADO()
      return this.onNavigate()

   function nextADO(nRecs)
      if pcount() <> 1
         nRecs = 1
      endif
      if not this.canNavigate()
         return
      endif
      if not this.rs.EOF
         this.rs.Move(nRecs)
         if this.rs.EOF
            this.rs.MoveLast()
         endif
         if this.rs.BOF
            this.rs.MoveFirst()
         endif
         class::populateADO()
      else
         this.rs.MoveLast()
         this.rowset.EOF = true
         class::populateADO()
      endif
      return this.onNavigate()

   function gotoADO(bookmark)
      this.rs.Move(bookmark)
      this.populateADO()
      return

   function canNavigateADO()
      return true

   function onNavigateADO()
      //set echo on ; x = 1
      //? this.rs.AbsolutePostion
      return true

   function populateADO()
      local i, k
      if this.rs.EOF or this.rs.BOF
      	return false
      endif
      for i = 1 to this.rs.fields.count
         k = i - 1
         if this.fields[i].FieldType = "Date"
            this.fields[i].value = ctod(this.rs.fields(k).value)
            this.fields[i].baseValue = ctod(this.rs.fields(k).value)
         else
            this.fields[i].value = this.rs.fields(k).value
            this.fields[i].baseValue = this.rs.fields(k).value
         endif
      next
      this.refreshControls()
      return true

   function dataLink()
      local oDL, conn, conStr
      oDL = new OleAutoClient("DataLinks")
      Conn = oDL.PromptNew()
      conStr = Conn.ConnectionString()
      oDL = null
      return conStr

   function atFirstADO()
      return ( this.rs.AbsolutePosition == 0 )

   function ADOCount()
      return this.rs.recordCount

   function atLastADO()
      local nCount
      nCount = class::ADOCount()
      return ( nCount == this.rs.AbsolutePosition )

   function bookmarksEqualText( book1, book2 )
      if ( PCOUNT() == 1 )
         book2 = this.bookObject
       endif
      return ( book1.cursor == book2.cursor )

   function CreateFields()
      local i, k, f
         clear
      for i = 1 to this.rs.fields.count
         k = i - 1
         f = new field()
         f.fieldName = this.rs.fields(k).name
         f.fieldType = this.getFieldType(this.rs.fields(k).type)
            f.value = this.rs.fields(k).value
         if f.FieldType = "Date"
            f.length = 20
         else
            f.length = this.rs.fields(k).definedsize
         endif
         f.onChange := {;this.parent.parent.modified := true}
         //f.onChange := {;class::onChange()}
         ? f.FieldName
         ? f.Type
         ? f.FieldType
         ? f.Length
         ? f.value
//         ? f.decimalLength
         this.rowset.fields.add(f)
         this.rowset.fields[i].baseValue = f.value
      next
      return

   function getFieldType(nType)
      local cType
      do case
         case nType =  adEmpty
            return "Empty"
         case nType =  adTinyInt
            return "TinyInt"
         case nType =  adSmallInt
            return "SmallInt"
         case nType =  adInteger
            return "Integer"
         case nType =  adBigInt
            return "BigInt"
         case nType =  adUnsignedTinyInt
            return "UnsignedTinyInt"
         case nType =  adUnsignedSmallInt
            return "UnsignedSmallInt"
         case nType =  adUnsignedInt
            return "UnsignedInt"
         case nType =  adUnsignedBigInt
            return "UnsignedBigInt"
         case nType =  adSingle
            return "Single"
         case nType =  adDouble
            return "Double"
         case nType =  adCurrency
            return "Currency"
         case nType =  adDecimal
            return "Decimal"
         case nType =  adNumeric
            return "Numeric"
         case nType =  adBoolean
            return "Boolean"
         case nType =  adError
            return "Error"
         case nType =  adUserDefined
            return "UserDefined"
         case nType =  adVariant
            return "Variant"
         case nType =  adIDispatch
            return "IDispatch"
         case nType =  adIUnknown
            return "IUnknown"
         case nType =  adGUID
            return "GUID"
         case nType =  adDate
            return "Date"
         case nType =  adDBDate
            return "DBDate"
         case nType =  adDBTime
            return "DBTime"
         case nType =  adDBTimeStamp
            return "DBTimeStamp"
         case nType =  adBSTR
            return "BSTR"
         case nType =  adChar
            return "Char"
         case nType =  adVarChar
            return "VarChar"
         case nType =  adLongVarChar
            return "LongVarChar"
         case nType =  adWChar
            return "WChar"
         case nType =  adVarWChar
            return "VarWChar"
         case nType =  adLongVarWChar
            return "LongVarWChar"
         case nType =  adBinary
            return "Binary"
         case nType =  adVarBinary
            return "VarBinary"
         case nType =  adLongVarBinary
            return "LongVarBinary"
         case nType =  adChapter
            return "Chapter"
         case nType =  adFileTime
            return "FileTime"
         case nType =  adDBFileTime
            return "DBFileTime"
         case nType =  adPropVariant
            return "PropVariant"
         case nType =  adVarNumeric
            return "VarNumeric"
         otherwise
            return ltrim(rtrim(nType)) // "Undefined"
      endcase

   function onChange()
      ? "In OnChange"
      return true

ENDCLASS
