/*

dBase Frame Control - header file - v 2.2
---------------------------------------------------------------------

*/

#ifndef _DBCWND_
#define _DBCWND_


#define LOWORD(x)       (bitand(x,0xffff))
#define HIWORD(x)       (bitand(bitrshift(x,16),0xffff))
#define MAKELONG(x,y)   (bitor(bitand(x,0xffff),bitlshift(y,16)))





//dBCWnd_AttachFrame

#define ID_STATBAR			      0xE801
#define ID_CLIENT			         0xE900

#define CW_TYPE_APP			      0x00000001
#define CW_TYPE_MDI			      0x00000002
#define CW_TYPE_SDI			      0x00000004
#define CW_TYPE_CON			      0x00000008

#define CW_STYLE_SYSMENU		   0x00000010
#define CW_STYLE_TOPMOST		   0x00000020
#define CW_STYLE_TOOLWND		   0x00000040
#define CW_STYLE_SIZEBOX		   0x00000080

#define CW_ALLOW_MOVEABLE		   0x00001000
#define CW_ALLOW_SIZEABLE		   0x00002000
#define CW_ALLOW_MINIMIZE		   0x00004000
#define CW_ALLOW_MAXIMIZE		   0x00008000

#define SBR_STYLE_NOBKGND		   0x00010000

#define DBR_STYLE_OUTEDGE		   0x00100000
#define DBR_STYLE_EXPAND		   0x00200000
#define DBR_STYLE_HIDING		   0x00400000


//AttachClass

#define CL_TYPE_TREEVIEW   		0x0002
#define CL_TYPE_NOTEBOOK   		0x0004


//dBCWnd_SetDock

#define HWND_STDTBAR	            -1 // identifier the standard toolbar

#define SD_DOCK			         0x0001
#define SD_POS			            0x0002	
#define SD_SIZE			         0x0004
#define SD_FLAGS		            0x0008

#define SD_POS_VERT		         0x0060
#define SD_POS_HORZ		         0x0090
#define SD_POS_FLOAT	            0x0100

#define SD_DOCK_RECALC		      0x1000


#define TBR_STATE_HIDE				0x00000001
#define TBR_STATE_DOCK				0x00000002
#define TBR_STATE_FLOAT				0x00000004
#define TBR_STATE_WRAP				0x00000008

#define TBR_ALIGN_TOP				0x00000010
#define TBR_ALIGN_LEFT				0x00000020
#define TBR_ALIGN_RIGHT				0x00000040
#define TBR_ALIGN_BOTTOM			0x00000080
											
#define TBR_ALLOW_ORIENT_HORZ		0x00000900
#define TBR_ALLOW_ORIENT_VERT		0x00000600
#define TBR_ALLOW_ORIENT_ANY		0x00000F00

#define TBR_ALLOW_MOVEABLE			0x00001000
#define TBR_ALLOW_SIZEABLE			0x00002000
#define TBR_ALLOW_FLOATABLE		0x00004000

#define TBR_STYLE_STRETCH			0x00010000
#define TBR_STYLE_WRAPABLE			0x00020000
#define TBR_STYLE_ROTATABLE		0x00040000
#define TBR_STYLE_ADJUSTABLE	   0x00080000

#define TBR_STYLE_OUTEDGE			0x00100000
#define TBR_STYLE_INNEDGE			0x00200000
#define TBR_STYLE_SIZEBDR			0x00400000
#define TBR_STYLE_GRIPPER			0x00800000
#define TBR_STYLE_CAPTION			0x01000000

#define TBR_TYPE_TOOLWND		   0x10000000
#define TBR_TYPE_TOOLBAR		   0x20000000
#define TBR_TYPE_TOOLBOX		   0x40000000



//dBCWnd_SetToolBar

#define STB_TBAR_STRUCT				0x00001
#define STB_TBAR_PARENT				0x00002 
#define STB_TBAR_STYLE				0x00004
#define STB_TBAR_POS					0x00008
#define STB_TBAR_BMPSIZE			0x00010
#define STB_TBAR_BTNWIDTH			0x00020
#define STB_TBAR_RECALC				0x00080 

#define STB_TBUTTON_STRUCT			0x00100
#define STB_TBUTTON_STYLE			0x00200
#define STB_TBUTTON_STATE			0x00400  
#define STB_TBUTTON_TEXT			0x01000
#define STB_TBUTTON_TEXT_TIP		0x02000
#define STB_TBUTTON_TEXT_STATUS	0x04000
#define STB_TBUTTON_MENU			0x08000

#define TBFLAGS_ADD              0x100
#define TBFLAGS_REM              0x200

//dBCWnd_SetToolMenu

#define STM_MENU_STRUCT          0x001
#define STM_MENU_STYLE           0x002
#define STM_MENUITEM_STRUCT      0x010
#define STM_MENUITEM_TYPE        0x020
#define STM_MENUITEM_STATE       0x040 
#define STM_MENUITEM_TEXT        0x100
#define STM_MENUITEM_TEXT_STATUS 0x200
#define STM_MENUITEM_SUB         0x400

//dBCWnd_SetScrollBar

#define SSB_MIN			         0x001	
#define SSB_MAX			         0x002
#define SSB_POS			         0x004
#define SSB_STEP		            0x008

#define SSB_RANGE		            0x003
#define SSB_ALL		            0x00F

#define SSB_HORZ		            0x010
#define SSB_VERT		            0x020
#define SSB_BOTH		            0x030

#define SSB_HIDE		            0x100
#define SSB_AUTO		            0x200
#define SSB_TEXT		            0x400	
#define SSB_PROGRESS	            0x800	




//SetTrackSize

#define STS_MIN			         0x001	
#define STS_MAX			         0x002

#define STS_ALL			         0x003



//SetTreeView

#define STV_EDITCTRL_LINK        	0x0001
#define STV_EDITCTRL_UNLINK      	0x0002
#define STV_EDITCTRL_ANY         	0x000F


#define STV_IMAGELIST_CREATE        0x0010
#define STV_IMAGELIST_ADD        	0x0020
#define STV_IMAGELIST_REMOVE        0x0040
#define STV_IMAGELIST_BLEND         0x0080

#define STV_TREEITEM_IMAGE          0x0100
#define STV_TREEITEM_IMAGE_SELECT   0x0200
#define STV_TREEITEM_IMAGE_CHECK    0x0400
#define STV_TREEITEM_IMAGE_UNCHECK  0x0800

#define STV_TREEITEM_IMAGE_NORMAL   0x0300
#define STV_TREEITEM_IMAGE_STATE    0x0C00   
#define STV_TREEITEM_IMAGE_ANY      0x0F00
#define STV_TREEITEM_IMAGE_INDEX    0x1000



//SetNoteBook

#define SNB_IMAGELIST_CREATE       0x0010

#define STV_TABITEM_IMAGE          0x0100




//Winuser.h 

#define GWL_ID                   (-12)

#define SW_HIDE                  0
#define SW_SHOW                  5

#define MF_BYCOMMAND             0x000
#define MF_STRING                0x000
#define MF_POPUP                 0x010
#define MF_MENUBARBREAK          0x020
#define MF_MENUBREAK             0x040
#define MF_RADIOCHECK            0x200
#define MF_BYPOSITION            0x400
#define MF_SEPARATOR             0x800

#define MF_GRAYED                0x001
#define MF_DISABLED              0x002
#define MF_CHECKED               0x008
#define MF_HILITE                0x080


//CommCtrl.h

#define TBSTYLE_BUTTON           0x0000
#define TBSTYLE_SEP              0x0001
#define TBSTYLE_CHECK            0x0002
#define TBSTYLE_GROUP            0x0004 
#define TBSTYLE_DROPDOWN         0x0008       
#define TBSTYLE_AUTOSIZE         0x0010
#define TBSTYLE_NOPREFIX         0x0020
#define TBSTYLE_SHOWTEXT         0x0040
#define TBSTYLE_WHOLEDROPDOWN    0x0080

#define TBSTYLE_VERTICAL         0x0080
#define TBSTYLE_TOOLTIPS         0x0100
#define TBSTYLE_WRAPABLE         0x0200
#define TBSTYLE_FLAT             0x0800
#define TBSTYLE_LIST             0x1000
#define TBSTYLE_TRANSPARENT      0x8000

#define TBSTYLE_EX_DRAWDDARROWS  0x0001
#define TBSTYLE_EX_MIXEDBUTTONS  0x0008
#define TBSTYLE_EX_HIDECLIPPEDB  0x0010 
#define TBSTYLE_EX_DOUBLEBUFFER  0x0080 

#define TBSTATE_CHECKED          0x0001
#define TBSTATE_PRESSED          0x0002
#define TBSTATE_ENABLED          0x0004
#define TBSTATE_HIDDEN           0x0008
#define TBSTATE_INDETERMINATE    0x0010
#define TBSTATE_WRAP             0x0020




#endif



